<?php
/*
  $Id: contrib_tracker.php,v 1.7.17 2009/09/05 17:33:32 SteveDallas Exp $

  05 Sep 2009 GCH 1.7.17 Complete rewrite of RDF file handling.
                           No longer requires or creates a cache file
                         Complete rewrite of XML parsing - no longer uses rdf_class.php 
						 Changed email message to include names and links to updated files
						   Only sends email the first time that a file is updated

  24 May 2009 GCH 1.7.15 Fixed detection/creation of local cache file for servers where DIR_FS_CATALOG != DIR_WS_CATALOG
                         Made the HTML output compliant with the HTML 4.01 DTD
                         Cleaned up the email notification option.  


  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
_________________________________________________________________

Contribution Tracker MODULE for osC Admin
By Admin of www.silvermoon-jewelry.com
Based on:
		Admin_notes: Original Code By: Robert Hellemans of www.RuddlesMills.com
		RSS News for OSC
These are LIVE SHOPS - So please, no TEST accounts etc...
We will report you to your ISP if you abuse our websites!
*/

require('includes/application_top.php');
$xmlURL='http://feedproxy.feedburner.com/osCommerce_Contributions';
$format = '%Y-%m-%d %H:%M:%S';

//Function to parse the RDF feed
//Does not rely on PHP XML parser due to issues.
    function parse_xml($text) {
      $reg_exp = '/<(\w+)[^>]*>(.*?)<\/\\1>/s';
      preg_match_all($reg_exp, $text, $match);
      foreach ($match[1] as $key=>$val) {
        if ( preg_match($reg_exp, $match[2][$key]) ) {
            $array[$val][] = parse_xml($match[2][$key]);
        } else {
		    if ( preg_match('/<!\[CDATA\[(.*?)\]\]>/s',$match[2][$key], $string) ) {
			    $array[$val] = $string[1];
			} else {
                $array[$val] = $match[2][$key];
			}
        }
      }
      return $array;
    } 

  if (!function_exists("file_get_contents")) {
  //get contents of file into a string
  //For compatibility with PHP4 < 4.3.0
    function file_get_contents($f) {
      $h = @fopen($f, 'rb'); //rss cached file path
      if ($h) {
        $data = '';
        while (!feof($h)) {
          $d .= fread($h, 8192);
	    }
        fclose($h);
      } else {
        $d = $false;
      }
	  return $d;
	}
  }

// Install a configuration key to determine whether to send email reports to store owner.  
// Set it to 'false'. (Can be changed in admin Config->E-Mail.)

if (CONTRIB_TRACKER_NOTIFICATION == 'CONTRIB_TRACKER_NOTIFICATION') {
  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, set_function) values ('Contrib Tracker Notification email', 'CONTRIB_TRACKER_NOTIFICATION', 'false', 'Send Contrib Tracker notifications to store owner', '12', '4815', now(), 'tep_cfg_select_option(array(\'true\', \'false\'),')");   
}

// Make the output minimal valid HTML
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
    <title><?php echo TITLE; ?></title>
  </head>
  <body>
<?php

$data = @file_get_contents($xmlURL);

if (!$data && (extension_loaded('curl') == 1)) {
  $data = curl_get_osc_contents($xmlURL);
}

//Initialize counters
$articlecount = 0;
$updated = 0;
$updatedlist = '';

if ($data) {
  $response = parse_xml($data);

  $articlelist = $response['rss'][0]['channel'][0];
  foreach ($articlelist['item'] as $article ) {
    $articlecount++;
    $thelink = $article['link'];
    $thetitle = $article['title'];
    $osc_rss_pubdate_raw = $article['pubDate'];
    $osc_rss_pubdate = strtotime($osc_rss_pubdate_raw);
    $osc_rss_pubdate = strftime ($format, $osc_rss_pubdate);

// add backslashes to characters that need escaping
    $thetitle=addslashes($thetitle);

// UPDATE THE CONTRIBUTIONS THAT ARE IN THE RSS FILE
    tep_db_query("UPDATE " . TABLE_CONTRIB_TRACKER . " SET status ='0', contr_last_modified = '" . $osc_rss_pubdate . "' where contrib_name = '" . $thetitle . "' and last_update < '" . $osc_rss_pubdate . "'");
    if (mysql_affected_rows()) {
	  $updated++;
      echo $thetitle . "<br>\n";
	  $updatedlist .= $thetitle . '  ' . $thelink . "<br>\n";
	}
  }
}

//send an email if any contribs need updating.
if ($updated > 0 && CONTRIB_TRACKER_NOTIFICATION == 'true') {
  $error = false;
  $name = "Contrib Tracker";
  $subject = "Contrib Tracker Summary";
  $enquiry = $articlecount . " contributions have been checked and the following " . $updated . " need updating.\n" . $updatedlist;
  if (tep_validate_email(STORE_OWNER_EMAIL_ADDRESS)) {
    tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, $subject, $enquiry, $name, STORE_OWNER_EMAIL_ADDRESS);
  }
}
echo "success\n";
?>
  </body>
</html>
